> For the complete documentation index, see [llms.txt](https://apertus.gitbook.io/vr/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://apertus.gitbook.io/vr/developers/architecture/configuration-ecosystem.md).

# Configuration ecosystem

ApertusVR can be configured by JSON config fiiles. *ApeSystem.json* contains settings for **ApertusCore** and beside that, each **ApertusPlugin** is configurable by its own JSON config file.

ApertusVR **Samples** (applications) can also manage multiple, separated configurations. For more details, please check the example below.

## Example

### Relative configs folder

If you would like to have your *configs* folder next to your application executable (*ApeHelloWorld*), just rewrite line 30 in samples/helloWorld/ApeHelloWorld.cpp

```
configDir << APE_SOURCE_DIR << "/samples/helloWorld/configs/";
```

to

```
configDir << "configs/";
```

In this scenario, you can start *ApeHelloWorld* application in 2 ways:

#### Option A

If you run it without any arguments, and it will display a list of configuration options ( folders inside configs folder, i.e. local\_monitor ) which you can select in terminal to start.

#### Option B

If you would like to start the application with a specific configuration, then start *ApeHelloWorld* as:

```
> ApeHelloWorld -c [config_folder_name]
```

### Absolute configs folder

If you would like to have your *configs* folders anywhere else (not relative to your ApeHelloWorld executable), just remove line 30 in samples/helloWorld/ApeHelloWorld.cpp:

```
configDir << APE_SOURCE_DIR << "/samples/helloWorld/configs/";
```

If you have your configs folder in \~/path/to/configs, then you can start ApeHelloWorld as:

```
> ApeHelloWorld -c ~/path/to/configs
```

## Configuration files

### ApeSystem.json

```
{
    "mainWindow": {
        "name": "Ape",
        "creator": "ApeOgreRenderPlugin"
    },
    "sceneSession": {
        "participantType": "Local",
        "uniqueUserNamePrefix": "",
        "sessionGUID": "",
        "sessionResourceLocation": [
            "/plugins/helloWorld/resources"
        ],
        "natPunchThroughServer": {
            "ip": "",
            "port": ""
        },
        "lobbyServer": {
            "useLobby": false,
            "ip": "",
            "port": "",
            "sessionName": "test"
        }
    },
    "pluginManager": {
        "plugins": [
            "ApeOgreRenderPlugin",
            "ApeOisUserInputPlugin",
            "ApeHelloWorldPlugin"
        ]
    }
}
```

As you can see, there are three objects: *mainWindow*, *sceneSession*, and *pluginManager*.

### MainWindow object

```
"mainWindow": {
    "name": "Ape",
    "creator": "ApeOgreRenderPlugin"
}
```

The *name* key is the name of the Window.\
The *creator* key is the name of the plugin which is going to make the window.

### *SceneSession object*

*Coming soon.*

### *PluginManager object*

```
"pluginManager": {
    "plugins": [
        "ApeOgreRenderPlugin",
        "ApeOisUserInputPlugin",
        "ApeHelloWorldPlugin"
    ]
}
```

The *plugins* object defines an array of plugin names. These plugins will be started on the initialization of  ApertusVR.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://apertus.gitbook.io/vr/developers/architecture/configuration-ecosystem.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
